明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 164|回复: 2

[经验] entmake创建标注,且自动修改标注文字大小

  [复制链接]
发表于 2019-10-3 10:28 | 显示全部楼层 |阅读模式
本示例为创建水平标注,且依据当长度太小时,自动修改标注文字的大小


  1. (defun c:tt(/ a b )
  2.   (setq
  3.     a(getpoint"\n起点")
  4.     b(getpoint"\n终点")
  5.   )
  6.   (DimnkX a b)
  7. )

  8. ;水平标注,起点、终点,图层=4制图_内空
  9. (defun DimnkX(a b / h x )
  10.   (setq
  11.     h 20
  12.     x(distance a b)
  13.   )
  14.   ;把点坐标从当前坐标系转换为世界坐标系
  15.   (setq a (trans a 1 0) b (trans b 1 0) )
  16.   (entmakex
  17.     (list
  18.       '(0 . "DIMENSION")
  19.       '(100 . "AcDbEntity")
  20.       '(8 . "4制图_内空")  ;图层
  21.       '(100 . "AcDbDimension")
  22.       (cons 10 (list(car a)(+(cadr a)h)))  ;标注线高度定义点坐标
  23.       '(70 . 32)  ;垂直/水平标注为32
  24.       '(1 . "")    ;文字替代内容,默认为空
  25.       '(3 . "内空")  ;标注样式
  26.       '(100 . "AcDbAlignedDimension")
  27.       (cons 13 a)  ;标注起点坐标
  28.       (cons 14 b) ;标注终点坐标
  29.       '(100 . "AcDbRotatedDimension")
  30.     )
  31.   )
  32.   (if (<= x 500)
  33.     (vlax-put-property  
  34.       (vlax-ename->vla-object(entlast))  
  35.       'TextHeight
  36.       (fix (* x 0.2))  
  37.     )
  38.   )
  39. )

发表于 2019-10-5 23:17 | 显示全部楼层
Thanks for sharing
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2019-10-16 03:20 , Processed in 0.216249 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表